"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignUpSection = void 0;
var react_1 = __importStar(require("react"));
var message_1 = require("primeobjects-ui-web-store/build/cjs/center/message");
var util_1 = require("./util");
var util_2 = require("primeobjects-ui-web-application/build/cjs/util");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var navigation_1 = require("next/navigation");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var cookie_1 = require("primeobjects-ui-web-basic/build/cjs/util/cookie");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lodash_1 = require("lodash");
var lottie_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/lottie"));
var SignUpSection = function (props) {
    var _a;
    var router = (0, navigation_1.useRouter)();
    var supportSSO = props.supportSSO, SignUpForm = props.SignUpForm, agreement = props.agreement, solution = props.solution;
    var _b = (0, react_1.useState)(""), doing = _b[0], setDoing = _b[1];
    var _c = (0, react_1.useState)(false), showAgreement = _c[0], setShowAgreement = _c[1];
    var _d = (0, react_1.useState)(""), errorMessage = _d[0], setErrorMessage = _d[1];
    var _e = (0, react_1.useState)({}), data = _e[0], setData = _e[1];
    var primaryColor = (0, primeobjects_helper_ui_1.getPrimaryColor)(solution);
    var buttonColorName = props.buttonColorName
        ? props.buttonColorName
        : primaryColor.name;
    (0, react_1.useEffect)(function () {
        var _a, _b;
        var newData = __assign(__assign({}, props.data), { email: ((_a = props.data) === null || _a === void 0 ? void 0 : _a.email)
                ? (_b = props.data) === null || _b === void 0 ? void 0 : _b.email
                : (0, cookie_1.getCookie)("sign-up-email") });
        setData(newData);
    }, [props.data]);
    var onChangeData = function (newData) {
        setData(newData);
        setErrorMessage("");
        if (props.onChangeData)
            props.onChangeData(newData);
    };
    var onSignUpError = function (error) {
        setDoing("");
        setErrorMessage(error);
        if (props.onSignUpError)
            props.onSignUpError(error);
    };
    var onSuccess = function () {
        if (props.onSuccess) {
            if (!props.onSuccess(data)) {
                setDoing("");
            }
        }
        else {
            (0, cookie_1.setCookie)("sign-in-email", data.email);
            router.push("/auth/activate-without-password?result=sign-up-success");
        }
    };
    var onClickSignIn = function () {
        if (props.onClickSignIn) {
            props.onClickSignIn(data);
        }
        else {
            router.push("/auth/sign-in");
        }
    };
    var getRootError = function (error) {
        if ((0, lodash_1.isNil)(error) || !(error === null || error === void 0 ? void 0 : error.error) || (error === null || error === void 0 ? void 0 : error.statusCode))
            return error;
        return getRootError(error.error);
    };
    var onSubmit = function () {
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var result, rootError, error_1;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 2, , 3]);
                        if (!(0, primeobjects_helper_util_1.isEmail)(data.email)) {
                            return [2 /*return*/, setErrorMessage("Please provide your email.")];
                        }
                        if (!(0, primeobjects_helper_util_1.isNonEmptyString)(data.role) &&
                            (0, lodash_1.filter)(solution.roles, function (r) { return r.signUp == true; }).length > 0) {
                            return [2 /*return*/, setErrorMessage("Please select a role.")];
                        }
                        if (!(0, primeobjects_helper_util_1.isNonEmptyString)(data.password)) {
                            return [2 /*return*/, setErrorMessage("Please provide your password.")];
                        }
                        if (data.password != data.confirmPassword) {
                            return [2 /*return*/, setErrorMessage("Your password and confirmation password do not match.")];
                        }
                        if (!data.signedAgreement && (agreement === null || agreement === void 0 ? void 0 : agreement.title)) {
                            return [2 /*return*/, setErrorMessage("Please read the Agreement & Notice and select 'I have read' checkbox.")];
                        }
                        setErrorMessage("");
                        setDoing("Processing ...");
                        return [4 /*yield*/, (0, util_2.callApiBase)(
                            // "http://localhost:3000/prod/sign-up",
                            "".concat(solution.apis.organization, "sign-up"), data, "POST", { solutionId: solution.id })];
                    case 1:
                        result = _c.sent();
                        if (result.error) {
                            console.error(result.error);
                            switch (result.error) {
                                case "ERROR_SIGNIN_NEED_EMAIL": {
                                    setDoing("");
                                    return [2 /*return*/, onSignUpError("Please provide a valid email.")];
                                }
                                case "ERROR_SIGNIN_NEED_PASSWORD": {
                                    setDoing("");
                                    return [2 /*return*/, onSignUpError("Please provide a valid password.")];
                                }
                                case "ERROR_SIGNIN_USERNOTFOUND": {
                                    setDoing("");
                                    return [2 /*return*/, onSignUpError("The user does not exist.")];
                                }
                                default: {
                                    setDoing("");
                                    rootError = getRootError(result.error);
                                    if ((rootError === null || rootError === void 0 ? void 0 : rootError.type) == "ERROR_USER_EXIST" ||
                                        ((_b = (_a = rootError === null || rootError === void 0 ? void 0 : rootError.error) === null || _a === void 0 ? void 0 : _a.detail) === null || _b === void 0 ? void 0 : _b.reason) == "user-exist") {
                                        return [2 /*return*/, onSignUpError("Failed to sign up.")];
                                    }
                                }
                            }
                        }
                        (0, message_1.sendMessage)("context-sign-up-success", "action", result);
                        onSuccess();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _c.sent();
                        if ((0, core_1.appTrackIsOn)())
                            console.error({ error: error_1 });
                        onSignUpError("Failed to sign up.");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); })();
    };
    var renderSSO = function () {
        return (supportSSO && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: "relative flex space-x-3" },
                react_1.default.createElement("div", { className: "min-w-0 flex-1 pt-1.5 flex justify-between space-x-4" },
                    react_1.default.createElement("div", { className: "text-base" }, "Sign up with social accounts"))),
            react_1.default.createElement("div", { className: "mt-5 mb-10 py-10 pl-8 border-0 border-l ml-3" },
                react_1.default.createElement("button", { style: { maxWidth: 250 }, className: "mb-5 w-full flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium bg-gray-100 hover:bg-gray-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-".concat(buttonColorName, "-500") },
                    react_1.default.createElement(svg_1.default, { src: "/icons/logo-google.svg", className: "flex justify-center", style: { width: 20, marginRight: 10 } }),
                    "Google"),
                react_1.default.createElement("button", { style: { maxWidth: 250 }, className: "mb-5 w-full flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium bg-gray-100 hover:bg-gray-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-".concat(buttonColorName, "-500") },
                    react_1.default.createElement(svg_1.default, { src: "/icons/logo-facebook.svg", className: "flex justify-center", style: { width: 20, marginRight: 10 } }),
                    "Facebook")))));
    };
    var onYesAgreement = function () {
        setData(__assign(__assign({}, data), { signedAgreement: true }));
        setShowAgreement(false);
    };
    var onNoAgreement = function () {
        setData(__assign(__assign({}, data), { signedAgreement: false }));
        setShowAgreement(false);
    };
    var onShowAgreement = function () {
        setShowAgreement(true);
    };
    return (react_1.default.createElement("div", { className: "mx-auto w-full max-w-md lg:w-96 ".concat(props.wrapperClassName ? props.wrapperClassName : ""), style: props.wrapperStyle ? props.wrapperStyle : {} },
        props.message && react_1.default.createElement("div", { className: "w-full" }, props.message),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h2", { className: "mt-6 text-3xl font-extrabold text-gray-900" }, "Sign up your account")),
        react_1.default.createElement("div", { className: "mt-8" },
            renderSSO(),
            supportSSO && (react_1.default.createElement("div", { className: "relative flex space-x-3" },
                react_1.default.createElement("div", { className: "h-8 w-8 rounded-full bg-green-500 flex flex- items-center justify-center ring-8 ring-white" },
                    react_1.default.createElement("svg", { className: "h-5 w-5 text-white", "x-description": "Heroicon name: solid/check", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 20 20", fill: "currentColor", "aria-hidden": "true" },
                        react_1.default.createElement("path", { fillRule: "evenodd", d: "M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z", clipRule: "evenodd" }))),
                react_1.default.createElement("div", { className: "min-w-0 flex-1 pt-1.5 flex justify-between space-x-4" },
                    react_1.default.createElement("span", { className: "text-base" }, "Or sign in with your email")))),
            react_1.default.createElement("div", { className: supportSSO
                    ? "mt-5 py-10 pl-8 border-0 border-l ml-3"
                    : "py-6" },
                !showAgreement && (react_1.default.createElement(SignUpForm, { agreement: agreement, data: data, onChangeData: onChangeData, solution: solution, alwaysShowLabel: true, errorMessage: errorMessage, onSubmitConfirmedPassword: onSubmit, onShowAgreement: onShowAgreement, doing: doing }, props.children)),
                doing && !showAgreement && (react_1.default.createElement("div", { className: "w-full" },
                    react_1.default.createElement("div", { style: {
                            width: 50,
                            height: 50
                        } },
                        react_1.default.createElement(lottie_1.default, { className: "w-full h-full", url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(primaryColor["600"]) })))),
                !doing && !showAgreement && (react_1.default.createElement("button", { className: "my-8 flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-".concat(buttonColorName, "-600 hover:bg-").concat(buttonColorName, "-700"), onClick: onSubmit }, "Submit")),
                !doing && showAgreement && (agreement === null || agreement === void 0 ? void 0 : agreement.content) && (react_1.default.createElement("div", { className: "w-full overflow-y-auto w-full border rounded py-1 px-2", style: { minHeight: 200, maxHeight: 400 }, dangerouslySetInnerHTML: {
                        __html: agreement === null || agreement === void 0 ? void 0 : agreement.content
                    } })),
                !doing && showAgreement && (agreement === null || agreement === void 0 ? void 0 : agreement.content) && (react_1.default.createElement("div", { className: "w-full flex flex-row" },
                    react_1.default.createElement("button", { className: "my-10 w-full mr-4 flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-emerald-600 hover:bg-emerald-700", onClick: onYesAgreement }, "Agree"),
                    react_1.default.createElement("button", { className: "my-10 w-full flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium bg-gray-100 hover:bg-gray-200", onClick: onNoAgreement }, "Disagree"))),
                !doing &&
                    ((_a = solution === null || solution === void 0 ? void 0 : solution.site) === null || _a === void 0 ? void 0 : _a.supportSignUp) != false &&
                    !showAgreement && (react_1.default.createElement(util_1.AuthSectionLink, { text: "Have a user account already? Click here to sign in.", onClick: onClickSignIn }))))));
};
exports.SignUpSection = SignUpSection;
exports.default = exports.SignUpSection;
//# sourceMappingURL=sign-up.js.map